<template>
<v-card height="100%" elevation-0>
   
  <v-form ref="applicationForm" dense> 
    <v-toolbar color="primary" dark dense>
        <v-icon @click="$emit('cancel')">close</v-icon>
        <v-toolbar-title>{{title}}</v-toolbar-title>
        <v-spacer></v-spacer>
        <v-btn flat dark @click="save()" :disabled="saving || !valid" :loading="saving"><v-icon>save</v-icon>&nbsp;{{saveButtonText}}</v-btn>
    </v-toolbar>
    
    <ApplicationForm :application="application" :mode="mode" @change="onchange"/>
    
  </v-form>
</v-card>
</template>

<script>
import ApplicationForm from './ApplicationForm.vue'
export default {
  name: 'ApplicationWizard',
  components: {
    ApplicationForm
  },
  props: ['value', 'title', 'mode', 'scope'],
  data() {
    return {
        saving: false,
        valid: true,
        application: Object.assign({ company: {}, contact: {} }, this.value),
        originalValue: this.value
    }
  },
  computed: {
    saveButtonText() { return this.saving ? this.$i18n.t("common.saving") : this.$i18n.t("common.save") }  
  },
  mounted() {
    this.onchange();
  },
  methods: {
    validateForm() {
        return this.$refs.applicationForm.validate() 
    },
    clearForm() {
        this.$refs.applicationForm.reset() 
    },
    onchange() {
        this.valid = this.validateForm();
    },
    async save() {
        try {
          this.valid = this.validateForm();
         
          if ( !this.valid ) {
            return;
          }
          this.saving = true
          
          let application = Object.assign({}, { scope: this.localScope }, this.application);
          
          this.$emit('close')
          
          this.$emit("input", application)

          let forceNull = []
          if ( this.mode == "edit" ) {
            forceNull = ['listingUrl', 'description', 'location']
          }

          this.$emit("save", application, false)
          
          const app = this.mode == "edit" ? 
                await this.$api.patchApplication(application.id, application, { forceNull: forceNull.toString() }) : 
                await this.$api.newApplication(application);
          
          this.$emit("input", app)
          
          this.$emit("save", app, true)
          this.$emit("success", app)       
          
          if ( this.mode != "edit" ) {
              this.clearForm()
          }
        }
        catch ( e ) {
          this.$logger.error(e.message);
          this.$emit("error")
        }
        finally {
          this.saving = false
        }
    }
  }
}
</script>

<style>
btn.loading-indicator {
  font-size: 30px;
}

btn.loading-indicator:after {
  overflow: hidden;
  display: inline-block;
  vertical-align: bottom;
  -webkit-animation: ellipsis steps(4,end) 900ms infinite;      
  animation: ellipsis steps(4,end) 900ms infinite;
  content: "\2026"; /* ascii code for the ellipsis character */
  width: 0px;
}
</style>


